local M = {}

local helper = require('scenario/scenariohelper')
local show = true
local reset = true

local function onScenarioChange(scenario)
	if scenario.state == 'pre-start' then
		TorqueScript.eval([[
			scenario_player0.position = "88.9213 205.221 0.346309";
			scenario_player0.rotation = "1 0 0 0";
			door1.position = "132.923 191.049 36.036";
		]])
		be:reloadStaticCollision();
		show = true
		reset = true
	end
end

local function onRaceWaypointReached(data)
	if data.vehicleName == 'scenario_player0' then
		if data.waypointName == 'WayPoint1' then
			helper.flashUiMessage('All paths are grey but vary in width', 5) 
		elseif data.waypointName == 'WayPoint2' then
			helper.flashUiMessage('This is a box; push it into a hole to open the door', 5) 
		elseif data.waypointName == 'WayPoint3' then
			helper.flashUiMessage('This is a portal; drive up to it and you will be teleported', 5) 
		end
	end
end

local function onBeamNGTrigger(data)
	if data.triggerName == 'trigger1' and data.subjectName == "key_box_1" then
		if show then
			helper.flashUiMessage('Wall opened!', 5)
			TorqueScript.eval([[
				door1.position = "0 0 0";
			]])
			be:reloadStaticCollision();
		end
		show = false
	elseif data.triggerName == 'portal1Forward' then
		helper.flashUiMessage('Teleported!', 5)
		TorqueScript.eval([[
			scenario_player0.position = "90.5661 123.244 84.2194";
		]])
	end
end

local function onPreRender(dt)
	if reset then
		TorqueScript.eval([[
			scenario_player0.position = "88.9213 205.221 0.346309";
			scenario_player0.rotation = "1 0 0 0";
		]])
		reset = false
	end
end

M.onBeamNGTrigger = onBeamNGTrigger
M.onRaceWaypointReached = onRaceWaypointReached
M.onScenarioChange = onScenarioChange
M.onPreRender = onPreRender
return M