local M = {}

local helper = require('scenario/scenariohelper')
local boxes = 0
local continue1 = true
local continue2 = true
local reset = true

local function onScenarioChange(scenario)
	if scenario.state == 'pre-start' then
		TorqueScript.eval([[
			scenario_player0.position = "88.9213 205.221 0.346309";
			scenario_player0.rotation = "1 0 0 0";
			pipe1.position = "139.522 173.697 58.5611";
			number2.position = "177.489 154.573 5.03831";
		]])
		be:reloadStaticCollision();
		continue1 = true
		continue2 = true
		reset = true
	end
end

local function onRaceWaypointReached(data)
	if data.vehicleName == 'scenario_player0' then
		if data.waypointName == 'WayPoint1' then
			helper.flashUiMessage('The number shows how many boxes can be deposited here', 5) 
		end
	end
end

local function onBeamNGTrigger(data)
	if data.triggerName == 'portal1A' then
		helper.flashUiMessage('Teleported!', 5)
		TorqueScript.eval([[
			scenario_player0.position = "88.5771 192.023 57.57";
		]])
	elseif data.triggerName == 'portal1B' then
		helper.flashUiMessage('Teleported!', 5)
		TorqueScript.eval([[
			scenario_player0.position = "91.153 121.146 10.8313";
		]])
	elseif data.triggerName == 'portal2A' then
		helper.flashUiMessage('Teleported!', 5)
		TorqueScript.eval([[
			scenario_player0.position = "88.4314 177.728 35.0372";
		]])
	elseif data.triggerName == 'portal2B' then
		helper.flashUiMessage('Teleported!', 5)
		TorqueScript.eval([[
			scenario_player0.position = "134.775 191.926 47.0683";
		]])
	end

	if data.triggerName == 'box' then
		if data.subjectName == 'key_box_1' and continue1 then
			boxes = boxes+1
			continue1 = false
		elseif data.subjectName == 'key_box_2' and continue2 then
			boxes = boxes+1
			continue2 = false
		end
	end
end

local function onPreRender(dt)
	if reset then
		TorqueScript.eval([[
			scenario_player0.position = "88.9213 205.221 0.346309";
			scenario_player0.rotation = "1 0 0 0";
		]])
		reset = false
	end
	if boxes == 1 then
		TorqueScript.eval([[
			number1.position = "177.489 154.573 5.03831";
			number2.position = "0 0 0";
		]])
	elseif boxes == 2 then
		TorqueScript.eval([[
			number0.position = "177.489 154.573 5.03831";
			number1.position = "0 0 0";
			pipe1.position = "139.522 173.697 45";
		]])
		helper.flashUiMessage('Pipe moved!', 5)
		be:reloadStaticCollision();
		boxes = 3
	end
end

M.onBeamNGTrigger = onBeamNGTrigger
M.onRaceWaypointReached = onRaceWaypointReached
M.onScenarioChange = onScenarioChange
M.onPreRender = onPreRender
return M