local M = {}

local helper = require('scenario/scenariohelper')
local continue1 = true
local continue2 = true
local boxes = 0
local reset = true
local show = true

local function onScenarioChange(scenario)
	if scenario.state == 'pre-start' then
		boxes = 0
		continue1 = true
		continue2 = true
		reset = true
		show = true
	end
end

local function onBeamNGTrigger(data)
    if data.triggerName == 'portalBox' then
		if data.subjectName == 'key_box_1' and continue1 then
			boxes = boxes+1
			continue1 = false
			show = true
			TorqueScript.eval([[
				key_box_1.position = "175.564 163.535 35.2764";
			]])
		elseif data.subjectName == 'key_box_2' and continue2 then
			boxes = boxes+1
			continue2 = false
			show = true
			TorqueScript.eval([[
				key_box_2.position = "175.564 163.535 35.2764";
			]])
		end
	elseif data.triggerName == 'portal1A' then
		helper.flashUiMessage('Teleported!', 1)
		TorqueScript.eval([[
			scenario_player0.position = "168.502 190.755 68.6629";
		]])
	elseif data.triggerName == 'portal1B' then
		if data.subjectName == 'scenario_player0' then
			helper.flashUiMessage('Teleported!', 1)
			TorqueScript.eval([[
				scenario_player0.position = "97.1425 123.69 0.0664992";
			]])
		elseif data.subjectName == 'key_box_2' then
			helper.flashUiMessage('Teleported!', 1)
			TorqueScript.eval([[
				key_box_2.position = "107 123.69 0.0664992";
			]])
		end
	elseif data.triggerName == 'portal2A' then
		helper.flashUiMessage('Teleported!', 1)
		TorqueScript.eval([[
			scenario_player0.position = "90.6195 128.768 68.7309";
		]])
	elseif data.triggerName == 'portal2B' then
		helper.flashUiMessage('Teleported!', 1)
		TorqueScript.eval([[
			scenario_player0.position = "88.3854 189.976 68.9064";
		]])
	end
end

local function onPreRender(dt)
	if reset then
		TorqueScript.eval([[
			scenario_player0.position = "88.9213 205.221 0.346309";
			scenario_player0.rotation = "1 0 0 0";
			number2.position = "177.481 161.69 43.3858";
			number1.position = "0 0 0";
			number0.position = "0 0 0";
			key_box_1.position = "160.572 163.535 0.107906";
			key_box_2.position = "151.473 190.143 68.2283";
		]])
		reset = false
		be:reloadStaticCollision();
	end
	if boxes == 1 and show then
		show = false
		TorqueScript.eval([[
			number1.position = "177.481 161.69 43.3858";
			number2.position = "0 0 0";
			door1.position = "0 0 0";
		]])
		helper.flashUiMessage('Door moved!', 5)
		be:reloadStaticCollision();
		show = false
	elseif boxes == 2 then
		TorqueScript.eval([[
			number0.position = "177.481 161.69 43.3858";
			number1.position = "0 0 0";
			door2.position = "0 0 0";
		]])
		helper.flashUiMessage('Door moved!', 5)
		be:reloadStaticCollision();
		show = false
		boxes = 3
	end
end

M.onBeamNGTrigger = onBeamNGTrigger
M.onRaceWaypoint = onRaceWaypoint
M.onScenarioChange = onScenarioChange
M.onPreRender = onPreRender
return M