local M = {}

local helper = require('scenario/scenariohelper')
local show = true

local function onScenarioChange(scenario)
	if scenario.state == 'pre-start' then
		TorqueScript.eval([[
			scenario_player0.position = "88.9213 205.221 0.346309";
			scenario_player0.rotation = "1 0 0 0";
			key_box_1.position = "163.91 200.698 23.0035";
			key_box_1.rotation = "1 0 0 0";
			pipe1.position = "186.679 148.171 41.8592";
			pipe1.rotation = "1 0 0 0";
		]])
		be:reloadStaticCollision();
	end
end

local function onBeamNGTrigger(data)
    if data.triggerName == 'trigger1' and data.subjectName == "key_box_1" then
		if (show) then
			helper.flashUiMessage('Pipe moved!', 5)
			TorqueScript.eval([[
				pipe1.position = "215.177 169.703 70.9789";
				pipe1.rotation = "0 1 0 19.7779";
			]])
			be:reloadStaticCollision();
			show = false
		end
    end
end

M.onBeamNGTrigger = onBeamNGTrigger
M.onRaceWaypoint = onRaceWaypoint
M.onScenarioChange = onScenarioChange
return M