local M = {}

local helper = require('scenario/scenariohelper')
local show = true
local reset = true
local i = 0
local gravityCommand = 'obj:setGravity(-9.81)'
local gravity = ''

local function onScenarioChange(scenario)
	if scenario and scenario.state == 'pre-start' then
		local gravityCommand = 'obj:setGravity(-9.81)'
		thePlayer:queueLuaCommand(gravityCommand)
		show = true
		reset = true
		gravity = ''
		i = 0
	end
end

local function onRaceWaypointReached(data)
	if data.vehicleName == 'scenario_player0' then
		if data.waypointName == 'WayPoint1' then
			helper.flashUiMessage('You can change gravity by driving into these areas; gravity = picture shown', 5)
		end
	end
end

local function onBeamNGTrigger(data)
	if data.triggerName == 'boxTrigger' and data.subjectName == "key_box_1" then
		if gravity == 'jupiter' then
			if show then
				helper.flashUiMessage('Wall opened!', 5)
				TorqueScript.eval([[
					door1.position = "0 0 0";
				]])
				be:reloadStaticCollision();
				show = false
			end
		else
			helper.flashUiMessage('The box does not have enough mass to move the wall...', 5)
		end
	elseif data.triggerName == 'jupiter' then
		if gravity == '' then
			gravity = 'jupiter'
			helper.flashUiMessage('Jupiter gravity activated!', 1)
		end
	elseif data.triggerName == 'moon' then
		if gravity == '' then
			gravity = 'moon'
			helper.flashUiMessage('Moon gravity activated!', 1)
		end
	end
end

local function onPreRender(dt)
	if reset then
		TorqueScript.eval([[
			scenario_player0.position = "88.9213 205.221 0.346309";
			scenario_player0.rotation = "1 0 0 0";
			door1.position = "79.5354 163.203 -0.184708";
		]])
		reset = false
	end
	if gravity ~= '' then
		i = i+1
		if gravity == 'jupiter' then
			local thePlayer = scenetree.findObject('scenario_player0')
			gravityCommand = 'obj:setGravity(-25)'
			thePlayer:queueLuaCommand(gravityCommand)
		elseif gravity == 'moon' then
			local thePlayer = scenetree.findObject('scenario_player0')
			gravityCommand = 'obj:setGravity(-1.6)'
			thePlayer:queueLuaCommand(gravityCommand)
		end
		if i >= 400 then
			local thePlayer = scenetree.findObject('scenario_player0')
			helper.flashUiMessage('Gravity deactivated', 1)
			i = 0
			gravity = ''
			gravityCommand = 'obj:setGravity(-9.81)'
			thePlayer:queueLuaCommand(gravityCommand)
		end
		local j = 10-i
		if j > 0 and j ~= 15 then 
			helper.flashUiMessage('Time Left: '..j..'', 1)
		end
	end
end

M.onBeamNGTrigger = onBeamNGTrigger
M.onScenarioChange = onScenarioChange
M.onPreRender = onPreRender
M.onRaceWaypointReached = onRaceWaypointReached
return M