local M = {}

local helper = require('scenario/scenariohelper')
local show = true
local show2 = true
local reset = true
local i = 0
local gravityCommand = 'obj:setGravity(-9.81)'
local gravity = ''

local function onScenarioChange(scenario)
	if scenario and scenario.state == 'pre-start' then
		local thePlayer = scenetree.findObject('scenario_player0')
		local gravityCommand = 'obj:setGravity(-9.81)'
		thePlayer:queueLuaCommand(gravityCommand)
		show = true
		reset = true
		gravity = ''
		i = 0
	end
end

local function onBeamNGTrigger(data)
	if data.triggerName == 'wall1' and data.subjectName ~= "scenario_player0" then
		if gravity == 'jupiter' then
			if show then
				helper.flashUiMessage('Wall opened!', 5)
				TorqueScript.eval([[
					door1.position = "1000 0 0";
				]])
				if data.subjectName == 'key_box_2' then
					TorqueScript.eval([[
						key_box_2.position = "1000 0 0";
					]])
				elseif data.subjectName == 'key_box_3' then
					TorqueScript.eval([[
						key_box_3.position = "1000 0 0";
					]])
				be:reloadStaticCollision();
				show = false
				end
			end
		else
			helper.flashUiMessage('The box does not have enough mass to move the wall...', 5)
		end
	elseif data.triggerName == 'wall2' and data.subjectName ~= "scenario_player0" then
		if gravity == 'jupiter' then
			if show2 then
				helper.flashUiMessage('Wall opened!', 5)
				TorqueScript.eval([[
					door2.position = "0 0 0";
				]])
				be:reloadStaticCollision();
				show2 = false
			end
			if data.subjectName == 'key_box_2' then
				TorqueScript.eval([[
					key_box_2.position = "0 0 0";
				]])
			elseif data.subjectName == 'key_box_2' then
				TorqueScript.eval([[
					key_box_3.position = "0 0 0";
				]])
			end
		else
			helper.flashUiMessage('The box does not have enough mass to move the wall...', 5)
		end
	elseif gravity == '' and data.triggerName == 'jupiter' then
		gravity = 'jupiter'
		helper.flashUiMessage('Jupiter gravity activated!', 1)
	elseif gravity == '' and data.triggerName == 'moon' then
		gravity = 'moon'
		helper.flashUiMessage('Moon gravity activated!', 1)
	elseif data.triggerName == 'portal1' then
		if gravity == '' then
			helper.flashUiMessage('Teleported!', 1)
		end
		TorqueScript.eval([[
			scenario_player0.position = "108.327 164.482 0.346309";
		]])
	elseif data.triggerName == 'portal2A' then
		if gravity == '' then
			helper.flashUiMessage('Teleported!', 1)
		end
		TorqueScript.eval([[
			scenario_player0.position = "171.59 129.292 68.3697";
		]])
	elseif data.triggerName == 'portal2B' then
		if gravity == '' then
			helper.flashUiMessage('Teleported!', 1)
		end
		TorqueScript.eval([[
			scenario_player0.position = "143.881 125.937 0.346309";
		]])
	elseif data.triggerName == 'portal3' then
		if gravity == '' then
			helper.flashUiMessage('Teleported!', 1)
		end
		if data.subjectName == 'scenario_player0' then
			TorqueScript.eval([[
				scenario_player0.position = "-8.67849 166.228 0.200859";
			]])
		elseif data.subjectName == 'key_box_2' then
			TorqueScript.eval([[
				key_box_2.position = "-3.67849 166.228 0.200859";
			]])
		end
	end
end

local function onPreRender(dt)
	if reset then
		TorqueScript.eval([[
			scenario_player0.position = "88.9213 205.221 0.346309";
			scenario_player0.rotation = "1 0 0 0";
			key_box_3.position = "147.95 150.049 60.0472";
			key_box_3.rotation = "1 0 0 0";
			key_box_2.position = "-2.17732 130.24 66.817";
			key_box_2.rotation = "1 0 0 0";
			door1.position = "79.5354 163.203 -0.184708";
			door2.position = "33.9984 111.604 -0.184708";
		]])
		reset = false
	end
	if gravity ~= '' then
		i = i+1
		if gravity == 'jupiter' then
			local thePlayer = scenetree.findObject('scenario_player0')
			gravityCommand = 'obj:setGravity(-25)'
			thePlayer:queueLuaCommand(gravityCommand)
		elseif gravity == 'moon' then
			local thePlayer = scenetree.findObject('scenario_player0')
			gravityCommand = 'obj:setGravity(-1.6)'
			thePlayer:queueLuaCommand(gravityCommand)
		end
		if i >= 600 then
			local thePlayer = scenetree.findObject('scenario_player0')
			helper.flashUiMessage('Gravity deactivated', 1)
			i = 0
			gravity = ''
			gravityCommand = 'obj:setGravity(-9.81)'
			thePlayer:queueLuaCommand(gravityCommand)
		end
		local j = 15-i
		if j > 0 and j ~= 15 then 
			helper.flashUiMessage('Time Left: '..j..'', 1)
		end
	end
end

M.onBeamNGTrigger = onBeamNGTrigger
M.onScenarioChange = onScenarioChange
M.onPreRender = onPreRender
return M