local M = {}

local helper = require('scenario/scenariohelper')
local show = true
local show2 = true
local reset = true
local continue1 = true
local continue2 = true
local continue3 = true
local i = 0
local gravityCommand = 'obj:setGravity(-9.81)'
local gravity = ''
local boxes = 0

local function onScenarioChange(scenario)
	if scenario and scenario.state == 'pre-start' then
		local thePlayer = scenetree.findObject('scenario_player0')
		local gravityCommand = 'obj:setGravity(-9.81)'
		thePlayer:queueLuaCommand(gravityCommand)
		show = true
		reset = true
		gravity = ''
		continue1 = true
		continue2 = true
		continue3 = true
		i = 0
		boxes = 0
	end
end

local function onBeamNGTrigger(data)
	if data.triggerName == 'wall1' and data.subjectName ~= "scenario_player0" then
		if gravity == 'jupiter' then
			if show then
				helper.flashUiMessage('Wall opened!', 5)
				TorqueScript.eval([[
					door1.position = "1000 0 0";
				]])
				be:reloadStaticCollision();
				if data.subjectName == 'key_box_2' then
					TorqueScript.eval([[
						key_box_2.position = "1000 0 0";
					]])
				elseif data.subjectName == 'key_box_3' then
					TorqueScript.eval([[
						key_box_3.position = "1000 0 0";
					]])
				elseif data.subjectName == 'key_box_1' then
					TorqueScript.eval([[
						key_box_1.position = "1000 0 0";
					]])
				show = false
				end
			end
		else
			helper.flashUiMessage('The box does not have enough mass to move the wall...', 5)
		end
	elseif data.triggerName == 'wall2' and data.subjectName ~= "scenario_player0" then
		if data.subjectName == 'key_box_2' and continue1 then
			TorqueScript.eval([[
				key_box_2.position = "1000 0 0";
			]])
			boxes = boxes+1
			continue1 = false
		elseif data.subjectName == 'key_box_3' and continue2 then
			TorqueScript.eval([[
				key_box_3.position = "1000 0 0";
			]])
			boxes = boxes+1
			continue2 = false
		elseif data.subjectName == 'key_box_1' and continue3 then
			TorqueScript.eval([[
				key_box_1.position = "1000 0 0";
			]])
			boxes = boxes+1
			continue3 = false
		end
	elseif data.triggerName == 'portal1A' then
		if gravity == '' then
			helper.flashUiMessage('Teleported!', 1)
		end
		TorqueScript.eval([[
			scenario_player0.position = "267.141 292.583 63.1221";
		]])
	elseif data.triggerName == 'portal1B' then
		if gravity == '' then
			helper.flashUiMessage('Teleported!', 1)
		end
		TorqueScript.eval([[
			scenario_player0.position = "90.0995 157.967 0.193783";
		]])
	elseif data.triggerName == 'portal2' then
		if gravity == '' then
			helper.flashUiMessage('Teleported!', 1)
		end
		if data.subjectName == 'scenario_player0' then
			TorqueScript.eval([[
				scenario_player0.position = "88.2435 175.139 0.193783";
			]])
		elseif data.subjectName == 'key_box_1' then
			TorqueScript.eval([[
				key_box_1.position = "94 175.139 1";
			]])
		elseif data.subjectName == 'key_box_2' then
			TorqueScript.eval([[
				key_box_2.position = "96 175.139 1";
			]])
		elseif data.subjectName == 'key_box_3' then
			TorqueScript.eval([[
				key_box_3.position = "98 175.139 1";
			]])
		end
	elseif data.triggerName == 'jupiter' then
		if gravity == '' then
			gravity = 'jupiter'
			helper.flashUiMessage('Jupiter gravity activated!', 1)
		end
	end
end

local function onPreRender(dt)
	if reset then
		TorqueScript.eval([[
			scenario_player0.position = "88.9213 205.221 0.346309";
			scenario_player0.rotation = "1 0 0 0";
			key_box_1.position = "270.052 282.136 0.0506985";
			key_box_1.rotation = "1 0 0 0";
			key_box_2.position = "229.861 164.851 26.5556";
			key_box_2.rotation = "1 0 0 0";
			key_box_3.position = "221.923 280.356 22.2734";
			key_box_3.rotation = "1 0 0 0";
			door1.position = "181.567 162.64 -0.184708";
			door2.position = "181.567 258.411 -0.184708";
			number0.position = "1000 0 0";
			number1.position = "1000 0 0;
			number2.position = "240.579 168.77 5.82519";
		]])
		local thePlayer = scenetree.findObject('scenario_player0')
		local gravityCommand = 'obj:setGravity(-9.81)'
		thePlayer:queueLuaCommand(gravityCommand)
		reset = false
	end
	if gravity ~= '' then
		i = i+1
		if gravity == 'jupiter' then
			local thePlayer = scenetree.findObject('scenario_player0')
			gravityCommand = 'obj:setGravity(-25)'
			thePlayer:queueLuaCommand(gravityCommand)
		end
		if i >= 700 then
			local thePlayer = scenetree.findObject('scenario_player0')
			helper.flashUiMessage('Gravity deactivated', 1)
			i = 0
			gravity = ''
			gravityCommand = 'obj:setGravity(-9.81)'
			thePlayer:queueLuaCommand(gravityCommand)
		end
		local j = 24-i
		if j > 0 and j ~= 24 then 
			helper.flashUiMessage('Time Left: '..j..'', 1)
		end
	end
	if boxes == 1 then
		TorqueScript.eval([[
			number2.position = "1000 0 0";
			number1.position = "240.579 168.77 5.82519";
		]])
	elseif boxes == 2 then
		helper.flashUiMessage('Door Opened!', 5)
		TorqueScript.eval([[
			door2.position = "1000 0 0";
			number1.position = "1000 0 0";
			number0.position = "240.579 168.77 5.82519";
		]])
		be:reloadStaticCollision();
		boxes = 0
	end
end

M.onBeamNGTrigger = onBeamNGTrigger
M.onScenarioChange = onScenarioChange
M.onPreRender = onPreRender
return M