local M = {}

local helper = require('scenario/scenariohelper')
local reset = true
local i = 0
local gravityCommand = 'obj:setGravity(-9.81)'
local gravity = ''

local function onScenarioChange(scenario)
	if scenario and scenario.state == 'pre-start' then
		local thePlayer = scenetree.findObject('scenario_player0')
		local gravityCommand = 'obj:setGravity(-9.81)'
		thePlayer:queueLuaCommand(gravityCommand)
		reset = true
		gravity = ''
		i = 0
	end
end

local function onBeamNGTrigger(data)
	if data.triggerName == 'wall1' and data.subjectName ~= "scenario_player0" then
		if gravity == 'jupiter' then
			helper.flashUiMessage('Wall opened!', 5)
			TorqueScript.eval([[
				door1.position = "1000 0 0";
				key_box_1.position = "1000 0 0";
			]])
			be:reloadStaticCollision();
		else
			helper.flashUiMessage('The box does not have enough mass to move the wall...', 5)
		end
	elseif data.triggerName == 'wall2' and data.subjectName ~= "scenario_player0" then
		if gravity == 'jupiter' then
			helper.flashUiMessage('Wall opened!', 5)
			TorqueScript.eval([[
				door2.position = "1000 0 0";
				key_box_2.position = "1000 0 0";
			]])
			be:reloadStaticCollision();
		else
			helper.flashUiMessage('The box does not have enough mass to move the wall...', 5)
		end
	elseif data.triggerName == 'wall3' and data.subjectName ~= "scenario_player0" then
		if gravity == 'jupiter' then
			helper.flashUiMessage('Wall opened!', 5)
			TorqueScript.eval([[
				door3.position = "1000 0 0";
				key_box_3.position = "1000 0 0";
			]])
			be:reloadStaticCollision();
		else
			helper.flashUiMessage('The box does not have enough mass to move the wall...', 5)
		end
	elseif data.triggerName == 'wall4' and data.subjectName ~= "scenario_player0" then
		if gravity == 'jupiter' then
			helper.flashUiMessage('Wall opened!', 5)
			TorqueScript.eval([[
				door4.position = "1000 0 0";
				key_box_4.position = "1000 0 0";
			]])
			be:reloadStaticCollision();
		else
			helper.flashUiMessage('The box does not have enough mass to move the wall...', 5)
		end
	elseif data.triggerName == 'portal1A' then
		if gravity == '' then
			helper.flashUiMessage('Teleported!', 1)
		end
		TorqueScript.eval([[
			scenario_player0.position = "266.509 169.638 0.625275";
		]])
	elseif data.triggerName == 'portal1B' then
		if gravity == '' then
			helper.flashUiMessage('Teleported!', 1)
		end
		TorqueScript.eval([[
			scenario_player0.position = "88.4519 159.218 0.625275";
		]])
	elseif data.triggerName == 'jupiter' then
		if gravity == '' then
			gravity = 'jupiter'
			helper.flashUiMessage('Jupiter gravity activated!', 1)
		end
	end
end

local function onPreRender(dt)
	if reset then
		TorqueScript.eval([[
			scenario_player0.position = "88.9213 205.221 0.346309";
			scenario_player0.rotation = "1 0 0 0";
			door1.position = "181.567 162.64 -0.184708";
			door2.position = "276.302 162.334 -0.0961307";
			door3.position = "225.559 213.43 -0.0961307";
			door4.position = "224.587 111.403 -0.0961307";
			key_box_1.position = "94.9969 129.387 0.0651154";
			key_box_2.position = "254.818 194.526 14.2112";
			key_box_3.position = "344.756 158.505 49.6884";
			key_box_4.position = "240.577 157.609 64.1308";
		]])
		local thePlayer = scenetree.findObject('scenario_player0')
		local gravityCommand = 'obj:setGravity(-9.81)'
		thePlayer:queueLuaCommand(gravityCommand)
		reset = false
	end
	if gravity ~= '' then
		i = i+1
		if gravity == 'jupiter' then
			local thePlayer = scenetree.findObject('scenario_player0')
			gravityCommand = 'obj:setGravity(-25)'
			thePlayer:queueLuaCommand(gravityCommand)
		end
		if i >= 600 then
			local thePlayer = scenetree.findObject('scenario_player0')
			helper.flashUiMessage('Gravity deactivated', 1)
			i = 0
			gravity = ''
			gravityCommand = 'obj:setGravity(-9.81)'
			thePlayer:queueLuaCommand(gravityCommand)
		end
		local j = 15-i
		if j > 0 and j ~= 15 then 
			helper.flashUiMessage('Time Left: '..j..'', 1)
		end
	end
end

M.onBeamNGTrigger = onBeamNGTrigger
M.onScenarioChange = onScenarioChange
M.onPreRender = onPreRender
return M