local M = {}

local helper = require('scenario/scenariohelper')
local reset = true
local i = 0
local j = 0
local k = 0
local l = 0
local m = 0
local boxes = 0
local scale = 1
local timer = 0
local secondPhase = false
local multiplier = 1
local slowMotion = false
local show = true
local speed = nil

local function success(speed)
    local result = {msg = 'Energy Disc Destroyed! The energy equilibrium has been restored and the testing is over. It was fun...while it lasted...'}
    scenarios.finish(result)
end

local function onScenarioChange(scenario)
	if scenario and scenario.state == 'pre-start' then
		reset = true
		i = 0
		j = 0
		k = 0
		l = 0
		m = 0
		boxes = 0
		timer = 0
		scale = 1
		multiplier = 1
		secondPhase = false
		slowMotion = false
		show = true
		helper.queueLuaCommandByName('scenario_player0', 'bullettime.set(0)')
	end
end

local function onBeamNGTrigger(data)
	if data.triggerName == 'deposit' and data.subjectName ~= "scenario_player0" then
		boxes = boxes+1
		if boxes <= 10 then
			helper.flashUiMessage('Wall opened!', 3)
		elseif show then
			show = false
			helper.flashUiMessage('Security Doors Open!', 3)
			helper.flashUiMessage('Take the blue road and get as much speed as possible and shut this thing down!', 7)
		end
		if boxes == 2 then
			TorqueScript.eval([[
				door1.position = "10000 0 0";
			]])
		elseif boxes == 4 then
			TorqueScript.eval([[
				door2.position = "10000 0 0";
			]])
		elseif boxes == 6 then
			TorqueScript.eval([[
				door3.position = "10000 0 0";
			]])
		elseif boxes == 8 then
			TorqueScript.eval([[
				door4.position = "10000 0 0";
			]])
		elseif boxes == 10 then
			TorqueScript.eval([[
				door5.position = "10000 0 0";
			]])
		elseif boxes == 12 then
			TorqueScript.eval([[
				doorFinal1.position = "10000 0 0";
				doorFinal2.position = "10000 0 0";
				doorFinal3.position = "10000 0 0";
			]])
		end
		if data.subjectName == 'key_box_1' then
			TorqueScript.eval([[
				key_box_1.position = "10000 0 0";
			]])
		elseif data.subjectName == 'key_box_2' then
			TorqueScript.eval([[
				key_box_2.position = "10000 0 0";
			]])
		elseif data.subjectName == 'key_box_3' then
			TorqueScript.eval([[
				key_box_3.position = "10000 0 0";
			]])
		elseif data.subjectName == 'key_box_4' then
			TorqueScript.eval([[
				key_box_4.position = "10000 0 0";
			]])
		elseif data.subjectName == 'key_box_5' then
			TorqueScript.eval([[
				key_box_5.position = "10000 0 0";
			]])
		elseif data.subjectName == 'key_box_6' then
			TorqueScript.eval([[
				key_box_6.position = "10000 0 0";
			]])
		end
		be:reloadStaticCollision();
	elseif data.triggerName == 'portalBox1' or data.triggerName == 'portalBox2' or data.triggerName == 'portalBox3' or data.triggerName == 'portalBox4' or data.triggerName == 'portalBox5' or data.triggerName == 'portalBox6' then
		if data.subjectName == 'key_box_1' then
			helper.flashUiMessage('Teleported!', 1)
			TorqueScript.eval([[
				key_box_1.position = "592.513 204.499 79.1235";
			]])
		elseif data.subjectName == 'key_box_2' then
			helper.flashUiMessage('Teleported!', 1)
			TorqueScript.eval([[
				key_box_2.position = "592.513 204.499 79.1235";
			]])
		elseif data.subjectName == 'key_box_3' then
			helper.flashUiMessage('Teleported!', 1)
			TorqueScript.eval([[
				key_box_3.position = "592.513 204.499 79.1235";
			]])
		elseif data.subjectName == 'key_box_4' then
			helper.flashUiMessage('Teleported!', 1)
			TorqueScript.eval([[
				key_box_4.position = "592.513 204.499 79.1235";
			]])
		elseif data.subjectName == 'key_box_5' then
			helper.flashUiMessage('Teleported!', 1)
			TorqueScript.eval([[
				key_box_5.position = "592.513 204.499 79.1235";
			]])
		elseif data.subjectName == 'key_box_6' then
			helper.flashUiMessage('Teleported!', 1)
			TorqueScript.eval([[
				key_box_6.position = "592.513 204.499 79.1235";
			]])
		end
	elseif data.triggerName == 'portal1A' then
		helper.flashUiMessage('Teleported!', 1)
		TorqueScript.eval([[
			scenario_player0.position = "461.886 284.584 27.5522";
		]])
	elseif data.triggerName == 'portal1B' then
		helper.flashUiMessage('Teleported!', 1)
		TorqueScript.eval([[
			scenario_player0.position = "452.425 78.0703 0.126678";
		]])
	elseif data.triggerName == 'portal2A' then
		helper.flashUiMessage('Teleported!', 1)
		TorqueScript.eval([[
			scenario_player0.position = "565.474 54.2238 0.126678";
		]])
	elseif data.triggerName == 'portal2B' then
		helper.flashUiMessage('Teleported!', 1)
		TorqueScript.eval([[
			scenario_player0.position = "530.376 109.283 0.126678";
		]])
	elseif data.triggerName == 'portal3A' then
		helper.flashUiMessage('Teleported!', 1)
		TorqueScript.eval([[
			scenario_player0.position = "466.184 283.541 66.5906";
		]])
	elseif data.triggerName == 'portal3B' then
		helper.flashUiMessage('Teleported!', 1)
		TorqueScript.eval([[
			scenario_player0.position = "531.079 53.2942 0.126678";
		]])
	elseif data.triggerName == 'portal4A' then
		helper.flashUiMessage('Teleported!', 1)
		TorqueScript.eval([[
			scenario_player0.position = "661.01 247.746 0.126678";
		]])
	elseif data.triggerName == 'portal4B' then
		helper.flashUiMessage('Teleported!', 1)
		TorqueScript.eval([[
			scenario_player0.position = "460.949 217.217 0.126678";
		]])
	elseif data.triggerName == 'endJump' then
		TorqueScript.eval([[
			darkmatterRing.position = "794.091 177.958 97.489";
		]])
		slowMotion = true
		helper.flashUiMessage('Dark matter sent!', 2)
		helper.queueLuaCommandByName('scenario_player0', 'bullettime.set(24)')
	end
end

local function onPreRender(dt)
	if reset then
		TorqueScript.eval([[
			scenario_player0.position = "452.425 123.722 0.125945";
			scenario_player0.rotation = "1 0 0 0";
			ring1.rotation = "1 0 0 0";
			ring2.rotation = "1 0 0 0";
			ring3.rotation = "1 0 0 0";
			ring4.rotation = "1 0 0 0";
			ring5.rotation = "1 0 0 0";
			ring1.position = "934.841 177.91 93.5701";
			ring2.position = "934.841 177.91 93.5701";
			ring3.position = "934.841 177.91 93.5701";
			ring4.position = "934.841 177.91 93.5701";
			ring5.position = "934.841 177.91 93.5701";
			fireball.setScale("0 0 0");
			door1.position = "547.455 272.484 -0.0523547";
			door2.position = "643.077 82.1665 -0.18471";
			door3.position = "643.599 272.618 -0.0523547";
			door4.position = "496.191 133.129 -0.18471";
			door5.position = "496.1 227.675 -0.184679";
			doorFinal1.position = "546.842 176.579 -0.184679";
			doorFinal2.position = "642.986 176.713 -0.184679";
			doorFinal3.position = "738.099 176.593 -0.184679";
			key_box_1.position = "519.083 79.3075 15.7841";
			key_box_2.position = "582.362 108.369 -9.88093e-006";
			key_box_3.position = "497.633 284.353 27.5438";
			key_box_4.position = "630.435 285.962 66.5937";
			key_box_5.position = "667.742 304.446 29.3284";
			key_box_6.position = "591.403 101.114 73.9716";
			darkmatterRing.position = "10000 0 0";
			darkmatterRing.setScale("0 0 0");
		]])
		be:reloadStaticCollision();
		reset = false
	end
	if slowMotion then
		if not secondPhase then
			scale = scale+0.01
			scale = scale*1.01
			TorqueScript.eval([[
				darkmatterRing.setScale("]]..scale..[[ ]]..scale..[[ 1");
			]])
			if multiplier < 10 then
				multiplier = multiplier+0.01
			elseif multiplier >= 10 then
				secondPhase = true
				scale = 0
			end
		else
			scale = scale+0.1
			scale = scale*1.01
			TorqueScript.eval([[
				fireball.setScale("]]..scale..[[ ]]..scale..[[ ]]..scale..[[");
			]])
			if scale >= 10 then
				TorqueScript.eval([[
					ring3.setScale("0 0 0");
					ring5.setScale("0 0 0");
					ring2.setScale("0 0 0");
					ring4.setScale("0 0 0");
					ring1.setScale("0 0 0");
					lighting1.setScale("0 0 0");
					lighting2.setScale("0 0 0");
					lighting3.setScale("0 0 0");
					lighting4.setScale("0 0 0");
					lighting5.setScale("0 0 0");
				]])
			end
			if scale >= 100 then
				success(scale)
			end
		end
		i = i+1*multiplier
		l = i+15*multiplier
		j = i+30*multiplier
		m = i+45*multiplier
		k = i+60*multiplier
	else
		i = i+4
		l = i+60
		j = i+120
		m = i+180
		k = i+240
	end
	TorqueScript.eval([[
		ring1.rotation =     "0 ]]..i..[[ ]]..i..[[ ]]..i..[[";
		ring4.rotation =     "0 ]]..l..[[ ]]..l..[[ ]]..l..[[";
		ring2.rotation =     "0 ]]..j..[[ ]]..j..[[ ]]..j..[[";
		ring5.rotation =     "0 ]]..m..[[ ]]..m..[[ ]]..m..[[";
		ring3.rotation =     "0 ]]..k..[[ ]]..k..[[ ]]..k..[[";
		lighting1.rotation = "0 ]]..i..[[ ]]..i..[[ ]]..i..[[";
		lighting2.rotation = "0 ]]..l..[[ ]]..l..[[ ]]..l..[[";
		lighting3.rotation = "0 ]]..j..[[ ]]..j..[[ ]]..j..[[";
		lighting4.rotation = "0 ]]..m..[[ ]]..m..[[ ]]..m..[[";
		lighting5.rotation = "0 ]]..k..[[ ]]..k..[[ ]]..k..[[";
	]])
end

M.onBeamNGTrigger = onBeamNGTrigger
M.onScenarioChange = onScenarioChange
M.onPreRender = onPreRender
return M